Index: /cpp/tests/geometry-tests.txt
===================================================================
--- /cpp/tests/geometry-tests.txt	(revision 811)
+++ /cpp/tests/geometry-tests.txt	(revision 812)
@@ -49,4 +49,12 @@
 RUNTEST
 
+TESTNAME:f1
+arg:-l
+arg:similarity.gen
+arg:Fast Lizard
+arg:2
+out:*INSERTPLATFORMDEPENDENTFILE*:geometry_goals/f1
+RUNTEST
+
 ##################################
 
Index: /cpp/tests/geometry_goals/f1.goal
===================================================================
--- /cpp/tests/geometry_goals/f1.goal	(revision 812)
+++ /cpp/tests/geometry_goals/f1.goal	(revision 812)
@@ -0,0 +1,59 @@
+//0
+p:sh=1, sx=0.1, sy=0.1, sz=0.1, vg=0.0
+p:sh=2, sx=0.5, sy=0.05, sz=0.05, vg=0.0, 0.0
+p:sh=2, sx=0.05, sy=0.5, sz=0.05, vr=0.0, vb=0.0
+p:sh=2, sx=0.05, sy=0.05, sz=0.5, vr=0.0, 0.0
+p:y=-0.649750002977198, -0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:y=-0.649750002977198, 0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:y=0.649750002977198, -0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:y=0.649750002977198, 0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:4.009699, -0.649750002977198, -0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:4.009699, -0.649750002977198, 0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:4.009699, 0.649750002977198, -0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:4.009699, 0.649750002977198, 0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:2.0048495, sh=2, sx=4.02960123031664, sy=0.05, sz=0.05, rz=0.0994291546863008, vg=0.0, 0.0
+p:2.0048495, sh=2, sx=0.05, sy=1.4986037809972, sz=0.05, rz=0.0994291546863008, vr=0.0, vb=0.0
+p:2.0048495, sh=2, sx=0.05, sy=0.05, sz=0.400000005960464, rz=0.0994291546863008, vr=0.0, 0.0
+p:0.3995, sh=3, sx=0.3995, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
+p:0.798998347976005, -0.449749999996966, sh=3, sx=0.44975, sy=0.200000002980232, sz=0.200000002980232, rz=1.57079265358979
+p:1.163325, sh=3, sx=0.364325, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
+p:1.879664, sh=3, sx=0.352014, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
+p:2.23167643518891, -0.426006999997126, sh=3, sx=0.426007, sy=0.200000002980232, sz=0.200000002980232, rz=1.57079265358979
+p:2.657685, sh=3, sx=0.426007, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
+p:3.5466955, sh=3, sx=0.4630035, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
+p:2.23167643518891, 0.426006999997126, sh=3, sx=0.426007, sy=0.200000002980232, sz=0.200000002980232, rz=-1.57079265358979
+p:0.798998347976005, 0.449749999996966, sh=3, sx=0.44975, sy=0.200000002980232, sz=0.200000002980232, rz=-1.57079265358979
+j:0, 1, sh=1
+j:0, 2, sh=1
+j:0, 3, sh=1
+j:0, 4, sh=1
+j:0, 5, sh=1
+j:0, 6, sh=1
+j:0, 7, sh=1
+j:0, 8, sh=1
+j:0, 9, sh=1
+j:0, 10, sh=1
+j:0, 11, sh=1
+j:0, 12, sh=1
+j:0, 13, sh=1
+j:0, 14, sh=1
+j:15, 16, sh=1
+j:15, 17, sh=1
+j:15, 23, sh=1
+j:17, 18, sh=1
+j:18, 19, sh=1
+j:18, 20, sh=1
+j:18, 22, sh=1
+j:20, 21, sh=1
+j:0, 15, sh=1
+
+# volume=0.000000
+# area=10.739018
+# sizes.x=4.029601 sizes.y=1.498604 sizes.z=0.400000
+# axes.x=(0.995061, 0.099265, 0.000000)
+# axes.y=(-0.099265, 0.995061, 0.000000)
+# axes.z=(0.000000, -0.000000, 1.000000)
+# box.x=[0.000000, 4.009699]
+# box.y=[-0.649750, 0.649750]
+# box.z=[-0.200000, 0.200000]
+
Index: /cpp/tests/go.sh
===================================================================
--- /cpp/tests/go.sh	(revision 811)
+++ /cpp/tests/go.sh	(revision 812)
@@ -1,3 +1,9 @@
-python3 ../../tester/tester.py -e '(.*)=../\1' -f SDK-tests.txt
-python3 ../../tester/tester.py -val -e '(.*)=../\1' -f geometry-tests.txt
-python3 ../../tester/tester.py -val -e '(.*)=../\1' -f similarity-tests.txt
+if [ "$1" != "-val" ]
+then
+	OPT_VAL=""
+else
+	OPT_VAL=$1
+fi
+python3 ../../tester/tester.py $OPT_VAL -e '(.*)=../\1' -f SDK-tests.txt
+python3 ../../tester/tester.py $OPT_VAL -e '(.*)=../\1' -f geometry-tests.txt
+python3 ../../tester/tester.py $OPT_VAL -e '(.*)=../\1' -f similarity-tests.txt