Index: cpp/PrintFloat/Dragon4.cpp
===================================================================
--- cpp/PrintFloat/Dragon4.cpp	(revision 833)
+++ cpp/PrintFloat/Dragon4.cpp	(revision 834)
@@ -24,5 +24,5 @@
 
 #include "Dragon4.h"
-#include "Math.h"
+#include "MathDragon4.h"
 #include <math.h>
 
@@ -866,5 +866,5 @@
     //  floor( log10(v) ) < ceil( (mantissaHighBitIdx + exponent) * log10(2) ) <= floor( log10(v) ) + 1
     const tF64 log10_2 = 0.30102999566398119521373889472449;
-    tS32 digitExponent = (tS32)(ceil(tF64((tS32)mantissaHighBitIdx + exponent) * log10_2 - 0.69));
+	tS32 digitExponent = (tS32)(ceil(tF64((tS32)mantissaHighBitIdx + exponent) * log10_2 - 0.69));
  
     // if the digit exponent is smaller than the smallest desired digit for fractional cutoff,
@@ -970,5 +970,5 @@
         // This is safe because (2^28 - 1) = 268435455 which is less than 429496729. This means
         // that all values with a highest bit at index 27 are within range.         
-        tU32 hiBlockLog2 = LogBase2(hiBlock);
+		tU32 hiBlockLog2 = LogBase2(hiBlock);
         RJ_ASSERT(hiBlockLog2 < 3 || hiBlockLog2 > 27);
         tU32 shift = (32 + 27 - hiBlockLog2) % 32;
Index: cpp/PrintFloat/Math.cpp
===================================================================
--- cpp/PrintFloat/Math.cpp	(revision 833)
+++ cpp/PrintFloat/Math.cpp	(revision 834)
@@ -23,5 +23,5 @@
 ******************************************************************************/
 
-#include "Math.h"
+#include "MathDragon4.h"
 
 //******************************************************************************
Index: cpp/PrintFloat/Math.h
===================================================================
--- cpp/PrintFloat/Math.h	(revision 833)
+++ 	(revision )
@@ -1,50 +1,0 @@
-/******************************************************************************
-  Copyright (c) 2014 Ryan Juckett
-  http://www.ryanjuckett.com/
- 
-  This software is provided 'as-is', without any express or implied
-  warranty. In no event will the authors be held liable for any damages
-  arising from the use of this software.
- 
-  Permission is granted to anyone to use this software for any purpose,
-  including commercial applications, and to alter it and redistribute it
-  freely, subject to the following restrictions:
- 
-  1. The origin of this software must not be misrepresented; you must not
-     claim that you wrote the original software. If you use this software
-     in a product, an acknowledgment in the product documentation would be
-     appreciated but is not required.
- 
-  2. Altered source versions must be plainly marked as such, and must not be
-     misrepresented as being the original software.
- 
-  3. This notice may not be removed or altered from any source
-     distribution.
-******************************************************************************/
-
-#ifndef RJ__Math_h
-#define RJ__Math_h
-
-#include "Standard.h"
-
-//******************************************************************************
-// Get the log base 2 of a 32-bit unsigned integer.
-// http://graphics.stanford.edu/~seander/bithacks.html#IntegerLogLookup
-//******************************************************************************
-tU32 LogBase2( tU32 val );
-
-//******************************************************************************
-// Get the log base 2 of a 64-bit unsigned integer.
-//******************************************************************************
-inline tU32 LogBase2( tU64 val )
-{
-    tU64 temp;
- 
-    temp = val >> 32;
-    if (temp)
-        return 32 + LogBase2((tU32)temp);
- 
-    return LogBase2((tU32)val);
-}
-
-#endif
Index: cpp/PrintFloat/MathDragon4.h
===================================================================
--- cpp/PrintFloat/MathDragon4.h	(revision 834)
+++ cpp/PrintFloat/MathDragon4.h	(revision 834)
@@ -0,0 +1,50 @@
+/******************************************************************************
+  Copyright (c) 2014 Ryan Juckett
+  http://www.ryanjuckett.com/
+ 
+  This software is provided 'as-is', without any express or implied
+  warranty. In no event will the authors be held liable for any damages
+  arising from the use of this software.
+ 
+  Permission is granted to anyone to use this software for any purpose,
+  including commercial applications, and to alter it and redistribute it
+  freely, subject to the following restrictions:
+ 
+  1. The origin of this software must not be misrepresented; you must not
+     claim that you wrote the original software. If you use this software
+     in a product, an acknowledgment in the product documentation would be
+     appreciated but is not required.
+ 
+  2. Altered source versions must be plainly marked as such, and must not be
+     misrepresented as being the original software.
+ 
+  3. This notice may not be removed or altered from any source
+     distribution.
+******************************************************************************/
+
+#ifndef RJ__Math_h
+#define RJ__Math_h
+
+#include "Standard.h"
+
+//******************************************************************************
+// Get the log base 2 of a 32-bit unsigned integer.
+// http://graphics.stanford.edu/~seander/bithacks.html#IntegerLogLookup
+//******************************************************************************
+tU32 LogBase2( tU32 val );
+
+//******************************************************************************
+// Get the log base 2 of a 64-bit unsigned integer.
+//******************************************************************************
+inline tU32 LogBase2( tU64 val )
+{
+    tU64 temp;
+ 
+    temp = val >> 32;
+    if (temp)
+        return 32 + LogBase2((tU32)temp);
+ 
+    return LogBase2((tU32)val);
+}
+
+#endif
Index: cpp/PrintFloat/PrintFloat.cpp
===================================================================
--- cpp/PrintFloat/PrintFloat.cpp	(revision 833)
+++ cpp/PrintFloat/PrintFloat.cpp	(revision 834)
@@ -31,5 +31,5 @@
 #include "PrintFloat.h"
 #include "Dragon4.h"
-#include "Math.h"
+#include "MathDragon4.h"
 
 #include <string.h>